package edu.lawrence.auction.interfaces;

import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import edu.lawrence.auction.interfaces.dtos.BillResponse;
import edu.lawrence.auction.interfaces.dtos.OfferResponse;
import edu.lawrence.auction.interfaces.dtos.ShippingCharge;
import edu.lawrence.auction.interfaces.dtos.ShippingConfirmation;
import edu.lawrence.auction.services.PurchaseService;

@RestController
@RequestMapping("/purchases")
@CrossOrigin(origins = "*")
public class PurchaseController {
	private PurchaseService purchaseService;
	
    public PurchaseController(PurchaseService purchaseService) {
        this.purchaseService = purchaseService;
    }
	
    @GetMapping("/concludeauctions")
    public String concludeauctions() {
    	purchaseService.concludeAuctions();
    	return "Done.";
    }
    
	@PostMapping("/offerresponse")
	public ResponseEntity<String> offerresponse(@RequestBody OfferResponse or) {
		if(purchaseService.saveOfferResponse(or))
			return ResponseEntity.status(HttpStatus.CREATED).body("Offer accepted");
		else {
			purchaseService.concludeAuctions();
			return ResponseEntity.status(HttpStatus.ACCEPTED).body("Offer cancelled");
		}
	}
	
	@PostMapping("/billshipping")
    public ResponseEntity<String> billshipping(@RequestBody ShippingCharge sc) {
		purchaseService.saveShipping(sc);
		return ResponseEntity.status(HttpStatus.ACCEPTED).body("Shipping charge entered");
	}
	
	@PostMapping("/billresponse")
	public ResponseEntity<String> billresponse(@RequestBody BillResponse br) {
		if(purchaseService.saveBillResponse(br))
			return ResponseEntity.status(HttpStatus.CREATED).body("Bill accepted");
		else {
			purchaseService.concludeAuctions();
			return ResponseEntity.status(HttpStatus.ACCEPTED).body("Bill cancelled");
		}
	}

	@PostMapping("/confirmshipping")
	public ResponseEntity<String> confirmshipping(@RequestBody ShippingConfirmation sc) {
		purchaseService.saveShipConfirm(sc);
		return ResponseEntity.status(HttpStatus.ACCEPTED).body("Tracking number entered");
	}
}

