package edu.lawrence.auction.interfaces.dtos;

import java.util.ArrayList;
import java.util.List;

import edu.lawrence.auction.entities.Auction;
import edu.lawrence.auction.entities.Tag;

public class AuctionDTO {
	private String auctionid;
	private String seller;
	private String item;
	private String description;
	private String imageurl;
	private int reserve;
	private String opens;
	private String closes;
	private boolean completed;
	private List<String> tags;
	
	public AuctionDTO() {
		this.tags = new ArrayList<String>();
	}

	public AuctionDTO(Auction core) {
		auctionid = core.getAuctionid().toString();
		seller = core.getSeller().getUserid().toString();
		item = core.getItem();
		description = core.getDescription();
		imageurl = core.getImageurl();
		reserve = core.getReserve();
		opens = core.getOpens().toString();
		closes = core.getCloses().toString();
		completed = core.getCompleted();
		tags = new ArrayList<String>();
		List<Tag> tagList = core.getTags();
		for(Tag t : tagList) {
			tags.add(t.getTag());
		}
	}
	
	public String getAuctionid() {
		return auctionid;
	}

	public void setAuctionid(String auctionid) {
		this.auctionid = auctionid;
	}

	public String getSeller() {
		return seller;
	}

	public void setSeller(String seller) {
		this.seller = seller;
	}

	public String getItem() {
		return item;
	}

	public void setItem(String item) {
		this.item = item;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public String getImageurl() {
		return imageurl;
	}

	public void setImageurl(String imageurl) {
		this.imageurl = imageurl;
	}

	public int getReserve() {
		return reserve;
	}

	public void setReserve(int reserve) {
		this.reserve = reserve;
	}

	public String getOpens() {
		return opens;
	}

	public void setOpens(String opens) {
		this.opens = opens;
	}

	public String getCloses() {
		return closes;
	}

	public void setCloses(String closes) {
		this.closes = closes;
	}
	
	public boolean getCompleted() {
		return completed;
	}
	
	public void setCompleted(boolean completed) {
		this.completed = completed;
	}
	
	public void setTags(List<String> tags) {
		this.tags = tags;
	}
	
	public List<String> getTags() {
		return tags;
	}
}
